package com.rubin.classloader;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

/**
 * Created by RubinChu on 2021/5/3 18:56
 */
public class ServletClassLoader extends ClassLoader {

    private String path;

    public ServletClassLoader(String path) {
        this.path = path;
    }

    @Override
    public Class<?> findClass(String name) throws ClassNotFoundException {
        byte[] cByte = this.loadClassData(name);
        return defineClass(name, cByte, 0, cByte.length);
    }

    private byte[] loadClassData(String name) {
        FileInputStream in = null;
        ByteArrayOutputStream out = null;
        try {
            in = new FileInputStream(new File(path + File.separator + name.replace(".", File.separator) + ".class"));
            out = new ByteArrayOutputStream();
            int c;
            while ((c = in.read()) != -1) {
                out.write(c);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                in.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                out.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return out.toByteArray();
    }

}
