package com.rubin.connector;

import com.rubin.engine.Engine;
import com.rubin.servlet.Request;
import com.rubin.servlet.Response;
import com.rubin.servlet.Servlet;

import java.io.File;
import java.io.InputStream;
import java.net.Socket;

public class RequestProcessor extends Thread {

    private Socket socket;
    private Engine engine;

    public RequestProcessor(Socket socket, Engine engine) {
        this.socket = socket;
        this.engine = engine;
    }

    @Override
    public void run() {
        try {
            InputStream inputStream = socket.getInputStream();
            // 封装Request对象和Response对象
            Request request = new Request(inputStream);
            Response response = new Response(socket.getOutputStream());
            Servlet servlet = engine.getHost().selectServlet(request.getUrl());
            if (servlet == null) {
                response.outputStaticFile(request.getUrl());
            } else {
                servlet.service(request, response);
            }
            socket.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
