package com.rubin.engine;

import com.rubin.LifeCycle;
import com.rubin.host.Host;
import com.rubin.reader.ServerXmlReader;

/**
 * Created by RubinChu on 2021/5/2 13:24
 */
public class Engine implements LifeCycle {

    private String name;

    private Host host;

    public Host getHost() {
        return host;
    }

    /**
     * 初始化
     */
    @Override
    public void init() {
        ServerXmlReader serverXmlReader = new ServerXmlReader();
        this.name = serverXmlReader.read("Engine.name");
        this.host = new Host();
        this.host.init();
    }

    /**
     * 启动
     */
    @Override
    public void start() {
        host.start();
    }

    /**
     * 销毁
     */
    @Override
    public void destroy() {
        host.destroy();
    }

}
