package com.rubin.server;

import com.rubin.LifeCycle;
import com.rubin.reader.ServerXmlReader;
import com.rubin.service.Service;

/**
 * 最外层容器 启动一个项目就是启动一个Server
 * Created by RubinChu on 2021/5/2 11:20
 */
public class Server implements LifeCycle {

    private String name;

    private Service service;

    /**
     * 初始化
     */
    @Override
    public void init() {
        ServerXmlReader serverXmlReader = new ServerXmlReader();
        this.name = serverXmlReader.read("Server.name");
        this.service = new Service();
        service.init();
    }

    /**
     * 启动
     */
    @Override
    public void start() {
        service.start();
    }

    /**
     * 销毁
     */
    @Override
    public void destroy() {
        service.destroy();
    }

}
